class Dataset(object):
    """
    A description of a single dataset.
    """

    def __init__(self, dataset_id, name, created_on):
        self._dataset_id = dataset_id
        self._name = name
        self._created_on = created_on

    @property
    def dataset_id(self):
        return self._dataset_id

    @property
    def name(self):
        return self._name

    @property
    def created_on(self):
        return self._created_on

    def __repr__(self):
        return 'Dataset({!r}, {!r}, {!r})'.format(self._dataset_id, self._name, self._created_on)


class DatasetList(object):
    """
    A list of datasets and the paging information related to it.
    """

    def __init__(self, items, count):
        self._items = [Dataset(i['id'], i['name'], i['created']) for i in items]
        self._count = count

    @property
    def items(self):
        return self._items

    @property
    def count(self):
        return self._count

    def __repr__(self):
        return 'DatasetList({!r}, {!r})'.format(self._items, self._count)
