class Prediction(object):
    def __init__(self, row, prediction, values):
        self._row = row
        self._prediction = prediction
        self._values = values

    @property
    def row(self):
        return self._row

    @property
    def prediction(self):
        return self._prediction

    @property
    def values(self):
        return self._values

    def __repr__(self):
        return 'Prediction({!r}, {!r}, {!r}'.format(self._row, self._prediction, self._values)

class PredictionList(object):
    def __init__(self, prediction_id, count, predictions, next_page=None, previous_page=None):
        self._prediction_id = prediction_id
        self._count = count
        self._predictions = [Prediction(p['rowId'], p['prediction'], p['predictionValues']) for p in predictions]
        self._next_link = next_page
        self._previous_link = previous_page

    @property
    def prediction_id(self):
        return self._prediction_id

    @property
    def count(self):
        return self._count

    @property
    def predictions(self):
        return self._predictions

    @property
    def next_link(self):
        return self._next_link

    @property
    def previous_link(self):
        return self._previous_link

    def __repr__(self):
        return 'PredictionList({!r}, {!r}, {!r})'.format(self._prediction_id, self._count, self._predictions)